Loading...
Searching...
No Matches
casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator > Class Template Reference

Representation of a statistics dataset used in statistics framework calculatations. More...

`#include <StatisticsDataset.h>`

## Classes

struct | ChunkData
| holds information about a data chunk. More...

## Public Member Functions

| StatisticsDataset ()
| StatisticsDataset (const StatisticsDataset &other)
| ~StatisticsDataset ()
StatisticsDataset< CASA_STATP > & | operator= (const StatisticsDataset< CASA_STATP > &other)
| use copy semantics, except for the data provider which uses reference semantics
void | addData (const DataIterator &first, uInt nr, uInt dataStride=1, Bool nrAccountsForStride=False)
| Add a dataset to an existing set of datasets on which statistics are to be calculated.
void | addData (const DataIterator &first, uInt nr, const DataRanges &dataRanges, Bool isInclude=True, uInt dataStride=1, Bool nrAccountsForStride=False)
void | addData (const DataIterator &first, const MaskIterator &maskFirst, uInt nr, uInt dataStride=1, Bool nrAccountsForStride=False, uInt maskStride=1)
void | addData (const DataIterator &first, const MaskIterator &maskFirst, uInt nr, const DataRanges &dataRanges, Bool isInclude=True, uInt dataStride=1, Bool nrAccountsForStride=False, uInt maskStride=1)
void | addData (const DataIterator &first, const WeightsIterator &weightFirst, uInt nr, uInt dataStride=1, Bool nrAccountsForStride=False)
void | addData (const DataIterator &first, const WeightsIterator &weightFirst, uInt nr, const DataRanges &dataRanges, Bool isInclude=True, uInt dataStride=1, Bool nrAccountsForStride=False)
void | addData (const DataIterator &first, const WeightsIterator &weightFirst, const MaskIterator &maskFirst, uInt nr, uInt dataStride=1, Bool nrAccountsForStride=False, uInt maskStride=1)
void | addData (const DataIterator &first, const WeightsIterator &weightFirst, const MaskIterator &maskFirst, uInt nr, const DataRanges &dataRanges, Bool isInclude=True, uInt dataStride=1, Bool nrAccountsForStride=False, uInt maskStride=1)
Bool | empty () const
| returns !
const std::vector< Int64 > & | getCounts () const
| get data counts associated with the underlying data sets
StatsDataProvider< CASA_STATP > * | getDataProvider ()
const StatsDataProvider< CASA_STATP > * | getDataProvider () const
Int64 | iDataset () const
Bool | increment (Bool includeIDataset)
void | incrementThreadIters (DataIterator &dataIter, MaskIterator &maskIter, WeightsIterator &weightsIter, uInt64 &offset, uInt nthreads) const
void | initIterators ()
void | initLoopVars (uInt64 &chunkCount, uInt &chunkStride, Bool &chunkHasRanges, DataRanges &chunkRanges, Bool &chunkIsIncludeRanges, Bool &chunkHasMask, uInt &chunkMaskStride, Bool &chunkHasWeights)
| used for threaded methods
void | initLoopVars (DataIterator &chunkData, uInt64 &chunkCount, uInt &chunkStride, Bool &chunkHasRanges, DataRanges &chunkRanges, Bool &chunkIsIncludeRanges, Bool &chunkHasMask, MaskIterator &chunkMask, uInt &chunkMaskStride, Bool &chunkHasWeights, WeightsIterator &chunkWeights)
| used for unthreaded methods
const ChunkData & | initLoopVars ()
void | initThreadVars (uInt &nBlocks, uInt64 &extra, uInt &nthreads, std::unique_ptr< DataIterator[]> &dataIter, std::unique_ptr< MaskIterator[]> &maskIter, std::unique_ptr< WeightsIterator[]> &weightsIter, std::unique_ptr< uInt64[]> &offset, uInt nThreadsMax) const
void | reset ()
void | resetIDataset ()
void | setData (const DataIterator &first, uInt nr, uInt dataStride=1, Bool nrAccountsForStride=False)
| setdata() clears any current datasets or data provider and then adds the specified data set as the first dataset in the (possibly new) set of data sets for which statistics are to be calculated.
void | setData (const DataIterator &first, uInt nr, const DataRanges &dataRanges, Bool isInclude=True, uInt dataStride=1, Bool nrAccountsForStride=False)
void | setData (const DataIterator &first, const MaskIterator &maskFirst, uInt nr, uInt dataStride=1, Bool nrAccountsForStride=False, uInt maskStride=1)
void | setData (const DataIterator &first, const MaskIterator &maskFirst, uInt nr, const DataRanges &dataRanges, Bool isInclude=True, uInt dataStride=1, Bool nrAccountsForStride=False, uInt maskStride=1)
void | setData (const DataIterator &first, const WeightsIterator &weightFirst, uInt nr, uInt dataStride=1, Bool nrAccountsForStride=False)
void | setData (const DataIterator &first, const WeightsIterator &weightFirst, uInt nr, const DataRanges &dataRanges, Bool isInclude=True, uInt dataStride=1, Bool nrAccountsForStride=False)
void | setData (const DataIterator &first, const WeightsIterator &weightFirst, const MaskIterator &maskFirst, uInt nr, uInt dataStride=1, Bool nrAccountsForStride=False, uInt maskStride=1)
void | setData (const DataIterator &first, const WeightsIterator &weightFirst, const MaskIterator &maskFirst, uInt nr, const DataRanges &dataRanges, Bool isInclude=True, uInt dataStride=1, Bool nrAccountsForStride=False, uInt maskStride=1)
void | setDataProvider (StatsDataProvider< CASA_STATP > *dataProvider)
| instead of setting and adding data "by hand", set the data provider that will provide all the data sets.

## Private Member Functions

void | _throwIfDataProviderDefined () const

## Private Attributes

std::vector< DataIterator > | _data
std::map< uInt, WeightsIterator > | _weights
| maps data to weights.
std::map< uInt, MaskIterator > | _masks
| maps data to masks
std::vector< Int64 > | _counts
std::vector< uInt > | _dataStrides
std::map< uInt, uInt > | _maskStrides
std::map< uInt, Bool > | _isIncludeRanges
std::map< uInt, DataRanges > | _dataRanges
StatsDataProvider< CASA_STATP > * | _dataProvider
Int64 | _idataset
std::vector< DataIterator >::const_iterator | _dend
std::vector< DataIterator >::const_iterator | _diter
std::vector< Int64 >::const_iterator | _citer
std::vector< uInt >::const_iterator | _dsiter
uInt | _dataCount
ChunkData | _chunk

## Detailed Description

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>
class casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >

Representation of a statistics dataset used in statistics framework calculatations.

This class is used internally by StatisticsAlgorithm and its derived classes. There should be no need for an API developer to make direct use of this class. It encapsulates the data-related portions of StatisticsAlgorithm and derived classes. To add and set data or to set a data provider, one should call the relevant methods in StatisticsAlgorithm which have been left unchanged for the convenience of the API developer. Those methods call the analogous methods in this class (and the methods in StatisticsAlgorithm also do necessary bookkeeping for the StatisticsAlgorithm and derived objects).

Definition at line 53 of file StatisticsDataset.h.

## Constructor & Destructor Documentation

## StatisticsDataset() [1/2]

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::StatisticsDataset | ( |  | ) |

Referenced by operator=(), and StatisticsDataset().

## StatisticsDataset() [2/2]

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::StatisticsDataset | ( | const StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator > & | other | ) |

References StatisticsDataset().

## ~StatisticsDataset()

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::~StatisticsDataset | ( |  | ) |

## Member Function Documentation

## _throwIfDataProviderDefined()

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

void casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::_throwIfDataProviderDefined | ( |  | ) | const

private

## addData() [1/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

void casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::addData | ( | const DataIterator & | first,
|  | const MaskIterator & | maskFirst,
|  | uInt | nr,
|  | const DataRanges & | dataRanges,
|  | Bool | isInclude = True,
|  | uInt | dataStride = 1,
|  | Bool | nrAccountsForStride = False,
|  | uInt | maskStride = 1 )

References DataRanges, casacore::False, first, and casacore::True.

## addData() [2/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

void casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::addData | ( | const DataIterator & | first,
|  | const MaskIterator & | maskFirst,
|  | uInt | nr,
|  | uInt | dataStride = 1,
|  | Bool | nrAccountsForStride = False,
|  | uInt | maskStride = 1 )

References casacore::False, and first.

## addData() [3/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

void casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::addData | ( | const DataIterator & | first,
|  | const WeightsIterator & | weightFirst,
|  | const MaskIterator & | maskFirst,
|  | uInt | nr,
|  | const DataRanges & | dataRanges,
|  | Bool | isInclude = True,
|  | uInt | dataStride = 1,
|  | Bool | nrAccountsForStride = False,
|  | uInt | maskStride = 1 )

References DataRanges, casacore::False, first, and casacore::True.

## addData() [4/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

void casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::addData | ( | const DataIterator & | first,
|  | const WeightsIterator & | weightFirst,
|  | const MaskIterator & | maskFirst,
|  | uInt | nr,
|  | uInt | dataStride = 1,
|  | Bool | nrAccountsForStride = False,
|  | uInt | maskStride = 1 )

References casacore::False, and first.

## addData() [5/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

void casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::addData | ( | const DataIterator & | first,
|  | const WeightsIterator & | weightFirst,
|  | uInt | nr,
|  | const DataRanges & | dataRanges,
|  | Bool | isInclude = True,
|  | uInt | dataStride = 1,
|  | Bool | nrAccountsForStride = False )

References DataRanges, casacore::False, first, and casacore::True.

## addData() [6/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

void casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::addData | ( | const DataIterator & | first,
|  | const WeightsIterator & | weightFirst,
|  | uInt | nr,
|  | uInt | dataStride = 1,
|  | Bool | nrAccountsForStride = False )

References casacore::False, and first.

## addData() [7/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

void casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::addData | ( | const DataIterator & | first,
|  | uInt | nr,
|  | const DataRanges & | dataRanges,
|  | Bool | isInclude = True,
|  | uInt | dataStride = 1,
|  | Bool | nrAccountsForStride = False )

References DataRanges, casacore::False, first, and casacore::True.

## addData() [8/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

void casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::addData | ( | const DataIterator & | first,
|  | uInt | nr,
|  | uInt | dataStride = 1,
|  | Bool | nrAccountsForStride = False )

Add a dataset to an existing set of datasets on which statistics are to be calculated.

nr is the number of points to be considered. If dataStride is greater than 1, when nrAccountsForStride=True indicates that the stride has been taken into account in the value of nr. Otherwise, it has not so that the actual number of points to include is nr/dataStride if nr % dataStride == 0 or (int)(nr/dataStride) + 1 otherwise. If one calls this method after a data provider has been set, an exception will be thrown. In this case, one should call setData(), rather than addData(), to indicate that the underlying data provider should be removed. dataRanges provide the ranges of data to include if isInclude is True, or ranges of data to exclude if isInclude is False. If a datum equals the end point of a data range, it is considered good (included) if isInclude is True, and it is considered bad (excluded) if isInclude is False.

References casacore::False, and first.

## empty()

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

Bool casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::empty | ( |  | ) | const

returns !

dataProvider && _data.empty()

## getCounts()

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

const std::vector< Int64 > & casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::getCounts | ( |  | ) | const

inline

get data counts associated with the underlying data sets

Definition at line 156 of file StatisticsDataset.h.

References _counts.

## getDataProvider() [1/2]

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

StatsDataProvider< CASA_STATP > * casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::getDataProvider | ( |  | ) |

inline

Definition at line 158 of file StatisticsDataset.h.

References _dataProvider.

## getDataProvider() [2/2]

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

const StatsDataProvider< CASA_STATP > * casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::getDataProvider | ( |  | ) | const

inline

Definition at line 162 of file StatisticsDataset.h.

References _dataProvider.

## iDataset()

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

Int64 casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::iDataset | ( |  | ) | const

inline

Definition at line 166 of file StatisticsDataset.h.

References _idataset.

## increment()

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

Bool casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::increment | ( | Bool | includeIDataset | ) |

## incrementThreadIters()

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

void casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::incrementThreadIters | ( | DataIterator & | dataIter,
|  | MaskIterator & | maskIter,
|  | WeightsIterator & | weightsIter,
|  | uInt64 & | offset,
|  | uInt | nthreads ) const

References casacore::offset().

## initIterators()

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

void casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::initIterators | ( |  | ) |

## initLoopVars() [1/3]

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

const ChunkData & casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::initLoopVars | ( |  | ) |

## initLoopVars() [2/3]

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

void casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::initLoopVars | ( | DataIterator & | chunkData,
|  | uInt64 & | chunkCount,
|  | uInt & | chunkStride,
|  | Bool & | chunkHasRanges,
|  | DataRanges & | chunkRanges,
|  | Bool & | chunkIsIncludeRanges,
|  | Bool & | chunkHasMask,
|  | MaskIterator & | chunkMask,
|  | uInt & | chunkMaskStride,
|  | Bool & | chunkHasWeights,
|  | WeightsIterator & | chunkWeights )

used for unthreaded methods

References DataRanges.

## initLoopVars() [3/3]

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

void casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::initLoopVars | ( | uInt64 & | chunkCount,
|  | uInt & | chunkStride,
|  | Bool & | chunkHasRanges,
|  | DataRanges & | chunkRanges,
|  | Bool & | chunkIsIncludeRanges,
|  | Bool & | chunkHasMask,
|  | uInt & | chunkMaskStride,
|  | Bool & | chunkHasWeights )

used for threaded methods

References DataRanges.

## initThreadVars()

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

void casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::initThreadVars | ( | uInt & | nBlocks,
|  | uInt64 & | extra,
|  | uInt & | nthreads,
|  | std::unique_ptr< DataIterator[]> & | dataIter,
|  | std::unique_ptr< MaskIterator[]> & | maskIter,
|  | std::unique_ptr< WeightsIterator[]> & | weightsIter,
|  | std::unique_ptr< uInt64[]> & | offset,
|  | uInt | nThreadsMax ) const

References casacore::offset().

## operator=()

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

StatisticsDataset< CASA_STATP > & casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::operator= | ( | const StatisticsDataset< CASA_STATP > & | other | ) |

use copy semantics, except for the data provider which uses reference semantics

References StatisticsDataset().

## reset()

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

void casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::reset | ( |  | ) |

## resetIDataset()

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

void casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::resetIDataset | ( |  | ) |

inline

Definition at line 204 of file StatisticsDataset.h.

References _idataset.

## setData() [1/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

void casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::setData | ( | const DataIterator & | first,
|  | const MaskIterator & | maskFirst,
|  | uInt | nr,
|  | const DataRanges & | dataRanges,
|  | Bool | isInclude = True,
|  | uInt | dataStride = 1,
|  | Bool | nrAccountsForStride = False,
|  | uInt | maskStride = 1 )

References DataRanges, casacore::False, first, and casacore::True.

## setData() [2/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

void casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::setData | ( | const DataIterator & | first,
|  | const MaskIterator & | maskFirst,
|  | uInt | nr,
|  | uInt | dataStride = 1,
|  | Bool | nrAccountsForStride = False,
|  | uInt | maskStride = 1 )

References casacore::False, and first.

## setData() [3/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

void casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::setData | ( | const DataIterator & | first,
|  | const WeightsIterator & | weightFirst,
|  | const MaskIterator & | maskFirst,
|  | uInt | nr,
|  | const DataRanges & | dataRanges,
|  | Bool | isInclude = True,
|  | uInt | dataStride = 1,
|  | Bool | nrAccountsForStride = False,
|  | uInt | maskStride = 1 )

References DataRanges, casacore::False, first, and casacore::True.

## setData() [4/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

void casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::setData | ( | const DataIterator & | first,
|  | const WeightsIterator & | weightFirst,
|  | const MaskIterator & | maskFirst,
|  | uInt | nr,
|  | uInt | dataStride = 1,
|  | Bool | nrAccountsForStride = False,
|  | uInt | maskStride = 1 )

References casacore::False, and first.

## setData() [5/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

void casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::setData | ( | const DataIterator & | first,
|  | const WeightsIterator & | weightFirst,
|  | uInt | nr,
|  | const DataRanges & | dataRanges,
|  | Bool | isInclude = True,
|  | uInt | dataStride = 1,
|  | Bool | nrAccountsForStride = False )

References DataRanges, casacore::False, first, and casacore::True.

## setData() [6/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

void casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::setData | ( | const DataIterator & | first,
|  | const WeightsIterator & | weightFirst,
|  | uInt | nr,
|  | uInt | dataStride = 1,
|  | Bool | nrAccountsForStride = False )

References casacore::False, and first.

## setData() [7/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

void casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::setData | ( | const DataIterator & | first,
|  | uInt | nr,
|  | const DataRanges & | dataRanges,
|  | Bool | isInclude = True,
|  | uInt | dataStride = 1,
|  | Bool | nrAccountsForStride = False )

References DataRanges, casacore::False, first, and casacore::True.

## setData() [8/8]

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

void casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::setData | ( | const DataIterator & | first,
|  | uInt | nr,
|  | uInt | dataStride = 1,
|  | Bool | nrAccountsForStride = False )

setdata() clears any current datasets or data provider and then adds the specified data set as the first dataset in the (possibly new) set of data sets for which statistics are to be calculated.

See addData() for parameter meanings.

References casacore::False, and first.

## setDataProvider()

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

void casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::setDataProvider | ( | StatsDataProvider< CASA_STATP > * | dataProvider | ) |

instead of setting and adding data "by hand", set the data provider that will provide all the data sets.

Calling this method will clear any other data sets that have previously been set or added.

## Member Data Documentation

## _chunk

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

ChunkData casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::_chunk

private

Definition at line 282 of file StatisticsDataset.h.

## _citer

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

std::vector<Int64>::const_iterator casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::_citer

private

Definition at line 279 of file StatisticsDataset.h.

## _counts

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

std::vector<Int64> casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::_counts

private

Definition at line 270 of file StatisticsDataset.h.

Referenced by getCounts().

## _data

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

std::vector<DataIterator> casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::_data

private

Definition at line 263 of file StatisticsDataset.h.

## _dataCount

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

uInt casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::_dataCount

private

Definition at line 281 of file StatisticsDataset.h.

## _dataProvider

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

StatsDataProvider<CASA_STATP>* casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::_dataProvider

private

Definition at line 275 of file StatisticsDataset.h.

Referenced by getDataProvider(), and getDataProvider().

## _dataRanges

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

std::map<uInt, DataRanges> casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::_dataRanges

private

Definition at line 274 of file StatisticsDataset.h.

## _dataStrides

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

std::vector<uInt> casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::_dataStrides

private

Definition at line 271 of file StatisticsDataset.h.

## _dend

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

std::vector<DataIterator>::const_iterator casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::_dend

private

Definition at line 278 of file StatisticsDataset.h.

## _diter

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

std::vector<DataIterator>::const_iterator casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::_diter

private

Definition at line 278 of file StatisticsDataset.h.

## _dsiter

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

std::vector<uInt>::const_iterator casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::_dsiter

private

Definition at line 280 of file StatisticsDataset.h.

## _idataset

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

Int64 casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::_idataset

private

Definition at line 277 of file StatisticsDataset.h.

Referenced by iDataset(), and resetIDataset().

## _isIncludeRanges

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

std::map<uInt, Bool> casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::_isIncludeRanges

private

Definition at line 273 of file StatisticsDataset.h.

## _masks

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

std::map<uInt, MaskIterator> casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::_masks

private

maps data to masks

Definition at line 269 of file StatisticsDataset.h.

## _maskStrides

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

std::map<uInt, uInt> casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::_maskStrides

private

Definition at line 272 of file StatisticsDataset.h.

## _weights

template<class AccumType, class DataIterator, class MaskIterator = const Bool *, class WeightsIterator = DataIterator>

std::map<uInt, WeightsIterator> casacore::StatisticsDataset< AccumType, DataIterator, MaskIterator, WeightsIterator >::_weights

private

maps data to weights.

maps are used rather than vectors because only some (or none) of the data sets in the _data vector may have associated weights, masks, and/or ranges.

Definition at line 267 of file StatisticsDataset.h.

The documentation for this class was generated from the following file:

- scimath/StatsFramework/StatisticsDataset.h